//+------------------------------------------------------------------+
//|                                                      Symbols.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "copyleft mladen"
#property link      "mladenfx@gmail.com"
#property indicator_chart_window

//
//
//
//
//

#define LIST_FOREX      1
#define LIST_CFD        2
#define LIST_FUTURES    4
#define LIST_CFDIndices 8
#define LIST_ALL       15
   
   extern int ListSymbolTypes = LIST_ALL;

//
//
//
//
//

string accountServer;
int    accountNumber;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()   { return(0); }
int deinit() { return(0); }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

#import "kernel32.dll"
    int _lclose (int);
    int _lopen  (string,int);
    int _llseek (int,int,int);
    int _lread  (int,string,int);
#import
#define sectorSize  1936
#define HFILE_ERROR -1
string  symbols[];

//
//
//
//
//

void getSymbolsList(int searchForWhat)
{ 
   ArrayResize(symbols,0);
   int fileHandle = FileOpenHistory("symbols.raw",FILE_BIN|FILE_READ);
   if (fileHandle == HFILE_ERROR) return;
    
   //
   //
   //
   //
   //

   int index = 0;
   for(int i=0;; i++)
   {
      FileSeek(fileHandle, sectorSize*i, SEEK_SET); if (FileIsEnding(fileHandle)) break;
      string symbolName = FileReadString(fileHandle,12);
             symbolName = StringSubstr(symbolName, 0);

      //
      //
      //
      //
      //
            
      int marginCalculationMode  = MarketInfo(symbolName, MODE_MARGINCALCMODE);
         bool           insertIt = (((searchForWhat & LIST_FOREX)     != 0) && marginCalculationMode ==0);
         if (!insertIt) insertIt = (((searchForWhat & LIST_CFD)       != 0) && marginCalculationMode ==1);
         if (!insertIt) insertIt = (((searchForWhat & LIST_FUTURES)   != 0) && marginCalculationMode ==2);
         if (!insertIt) insertIt = (((searchForWhat & LIST_CFDIndices)!= 0) && marginCalculationMode ==3);
         if (!insertIt) continue;

      //
      //
      //
      //
      //
              
      ArrayResize(symbols,index+1); symbols[index] = symbolName; index++;
   } 
   if (fileHandle>-1) FileClose(fileHandle);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   if (AccountServer()!=accountServer || AccountNumber()!=accountNumber)
   {
      accountServer = AccountServer();
      accountNumber = AccountNumber();
         getSymbolsList(ListSymbolTypes);      
   }
   
   //
   //
   //
   //
   //

   string tempList= "";
   int    limit   = ArraySize(symbols);
   for(int i=0;i<limit;i++)
   {
      if ((i%10)==0) tempList = tempList+"\n";
                     tempList = tempList+symbols[i]+"   ";
   }
   Comment(tempList);
   return(0);
}